let gulp = require('gulp'),
    sass = require('gulp-sass')(require('sass')),
    sassGlob = require('gulp-sass-glob'),
    autoprefixer = require('gulp-autoprefixer'),
    csscombx = require('gulp-csscombx'),
    pxtorem = require('gulp-pxtorem'),
    remToPx = require('gulp-rem-to-px')

// pxToRemOptions
const pxToRemOptions = {
  rootValue: 16, // Set the base font size (1rem = 16px)
  unitPrecision: 5, // The decimal numbers to allow in rem units
  propList: ['*'], // Convert all properties
  selectorBlackList: [], // Ignore selectors
  replace: true, // Replace px values with rem values
  mediaQuery: false, // Ignore media queries
};

// remtopx
gulp.task('remtopx', function () {

  return gulp.src('./sass/components/**/*.scss')
    .pipe(remToPx({
      fontSize : 10
    }))
    .pipe(gulp.dest('./sass/components'));

});

// scss 
gulp.task('scss', function () {

  return gulp.src('./sass/components/**/*.scss')
    .pipe(sassGlob())
    .pipe(csscombx())
    .pipe(gulp.dest('./sass/components'));

});

// sass
gulp.task('sass', function () {

  return gulp.src('./sass/*.scss')

    .pipe(sassGlob())
    .pipe(sass())
    .pipe(pxtorem(pxToRemOptions))
    .pipe(autoprefixer())
    .pipe(csscombx())
    .pipe(gulp.dest('./css'))

});

gulp.task('default', gulp.series('sass', function () {
  gulp.watch( './sass/**/*.scss', gulp.series('sass'));
}));
